Status: Closed

Priority: Normal

Assignee: René-Luc ReLuc

Category: QGIS Server

Affected QGIS version:2.8.5 Regression?: No

Operating System: ubuntu Easy fix?: No

Pull Request or Patch supplied:No Resolution: end of life

Crashes QGIS or corrupts data:No Copied to github as #: 22246

Description

We have had to resort to parsing WFS XML responses since there seems to be some keyword case sensitivity in either QGIS server or

OWSLib that's preventing unfettered OGC communication.

I wasn't able to diagnose if the problem is with QGIS or OWSLib

History

#1 - 2016-02-08 01:24 PM - Jukka Rahkonen

It would be much easier to analyze if the XML from QGIS server is valid if you could add a sample.

#2 - 2016-02-16 05:24 AM - René-Luc ReLuc

- Assignee set to René-Luc ReLuc

#3 - 2016-03-29 07:42 AM - Gavin Fleming

- File GetCapabilities.xml added

GetCapabilities XML attached.

By the way, this is the response when I try to use OWSLib:

Based on the documentation, they have three WFS versions supported:

Version 1.0.0

```

from owslib.wfs import WebFeatureService

wfs11 = WebFeatureService(url='http://129.232.164.58:6003/cgi-bin/qgis_mapserv.fcgi?map=/qgis/docs/projects/straffontein_SCH032.qgs',

version='1.0.0')

Traceback (most recent call last):

  File "<console>", line 1, in <module>

  File "/usr/local/lib/python2.7/site-packages/owslib/wfs.py", line 36, in WebFeatureService

    timeout=timeout)

  File "/usr/local/lib/python2.7/site-packages/owslib/feature/wfs100.py", line 72, in new

    obj.__init__(url, version, xml, parse_remote_metadata, timeout)

  File "/usr/local/lib/python2.7/site-packages/owslib/feature/wfs100.py", line 94, in init
    self._buildMetadata(parse_remote_metadata)

  File "/usr/local/lib/python2.7/site-packages/owslib/feature/wfs100.py", line 104, in _buildMetadata

    self.provider=ServiceProvider(serviceelem)

  File "/usr/local/lib/python2.7/site-packages/owslib/feature/wfs100.py", line 283, in init

    self.keywords = extract_xml_list(self._root.find(nspath('Keywords')))

  File "/usr/local/lib/python2.7/site-packages/owslib/util.py", line 540, in extract_xml_list

    keywords = [re.split(r'[\

\

]+',f.text) for f in elements if f.text]

TypeError: 'NoneType' object is not iterable

```

Version 1.1.0

```

from owslib.wfs import WebFeatureService

wfs11 = WebFeatureService(url='http://129.232.164.58:6003/cgi-bin/qgis_mapserv.fcgi?map=/qgis/docs/projects/straffontein_SCH032.qgs',

version='1.1.0')

Traceback (most recent call last):

  File "<console>", line 1, in <module>

  File "/usr/local/lib/python2.7/site-packages/owslib/wfs.py", line 39, in WebFeatureService

    timeout=timeout)

  File "/usr/local/lib/python2.7/site-packages/owslib/feature/wfs110.py", line 53, in new

    obj.__init__(url, version, xml, parse_remote_metadata, timeout)

  File "/usr/local/lib/python2.7/site-packages/owslib/feature/wfs110.py", line 76, in init

    self._buildMetadata(parse_remote_metadata)

  File "/usr/local/lib/python2.7/site-packages/owslib/feature/wfs110.py", line 83, in _buildMetadata

    self.identification=ServiceIdentification(val,self.owscommon.namespace)

  File "/usr/local/lib/python2.7/site-packages/owslib/ows.py", line 47, in init

    val = self._root.find(util.nspath('Title', namespace))

AttributeError: 'NoneType' object has no attribute 'find'

```

Version 2.0.0

```

from owslib.wfs import WebFeatureService

wfs11 = WebFeatureService(url='http://129.232.164.58:6003/cgi-bin/qgis_mapserv.fcgi?map=/qgis/docs/projects/straffontein_SCH032.qgs',

version='2.0.0')

Traceback (most recent call last):

  File "<console>", line 1, in <module>

  File "/usr/local/lib/python2.7/site-packages/owslib/wfs.py", line 42, in WebFeatureService

    timeout=timeout)
  File "/usr/local/lib/python2.7/site-packages/owslib/feature/wfs200.py", line 61, in new

    obj.__init__(url, version, xml, parse_remote_metadata, timeout)

  File "/usr/local/lib/python2.7/site-packages/owslib/feature/wfs200.py", line 85, in init

    self._buildMetadata(parse_remote_metadata)

  File "/usr/local/lib/python2.7/site-packages/owslib/feature/wfs200.py", line 92, in _buildMetadata

    self.identification=ServiceIdentification(serviceidentelem)

  File "/usr/local/lib/python2.7/site-packages/owslib/ows.py", line 47, in init

    val = self._root.find(util.nspath('Title', namespace))

AttributeError: 'NoneType' object has no attribute 'find'

```

#4 - 2016-04-08 06:37 AM - René-Luc ReLuc

QGIS Server only provides WFS version 1.0.0.

It seems that OWSLib is waiting for Keywords in capabilities.

#5 - 2017-05-01 01:06 AM - Giovanni Manghi

- Regression? set to No

- Easy fix? set to No

#6 - 2019-03-09 03:12 PM - Giovanni Manghi

- Resolution set to end of life

- Status changed from Open to Closed

End of life notice: QGIS 2.18 LTR

Source:

http://blog.qgis.org/2019/03/09/end-of-life-notice-qgis-2-18-ltr/

Files

GetCapabilities.xml 16.9 KB 2016-03-29 Gavin Fleming

2024-03-20 3/3

http://blog.qgis.org/2019/03/09/end-of-life-notice-qgis-2-18-ltr/

